###################################################
### chunk number 1: 
###################################################
 options(continue="  ")


###################################################
### chunk number 2: 
###################################################
 options(continue="  ")


###################################################
### chunk number 3: 
###################################################
library("dse2")


###################################################
### chunk number 4: 
###################################################
data(egJofF.1dec93.data, package="dse1")
eg4.DSE.data<- egJofF.1dec93.data
eg4.DSE.model <- estVARXls(eg4.DSE.data) 
outputData(eg4.DSE.data) <- outputData(eg4.DSE.data, 
 series=c(1,2,6,7)) 
eg4.DSE.model <- estVARXls(eg4.DSE.data) 

new.data <- TSdata(
   input = ts(rbind(inputData(eg4.DSE.data),
                    matrix(.1,10,1)),
            start=start(eg4.DSE.data), frequency = frequency(eg4.DSE.data)),
   output = ts(rbind(outputData(eg4.DSE.data), matrix(.3,5,4)),
            start=start(eg4.DSE.data), frequency = frequency(eg4.DSE.data))) 

if(require("padi") & require("dsepadi"))
 eg4.DSE.data.names <-TSPADIdata(
  input = "B14017", input.transforms= "diff", input.names="R90",
  output = c("P100000", "V2036138", "V2062811", "b3400"),
  output.transforms=c("percentChange", "percentChange",
          "percentChange", "percentChange"),
   output.names=c("CPI", "GDP", "employment", "PFX"),
   server="ets")



###################################################
### chunk number 5: 
###################################################
eg4.DSE.model <- estVARXls(eg4.DSE.data) 


###################################################
### chunk number 6: 
###################################################
if(require("padi") && checkPADIserver("ets"))
  new.data <- freeze(eg4.DSE.data.names) #requires padi and correct databases 


###################################################
### chunk number 7: 
###################################################
new.data <- TSdata(input=ts(rbind(inputData(eg4.DSE.data), matrix(.1,10,1)),
   start = start(eg4.DSE.data), frequency = frequency(eg4.DSE.data)),
   output = ts(rbind(outputData(eg4.DSE.data), matrix(.3,5,4)),
   start = start(eg4.DSE.data), frequency = frequency(eg4.DSE.data))) 


###################################################
### chunk number 8: 
###################################################
z <- l(TSmodel(eg4.DSE.model), trimNA(new.data)) 


###################################################
### chunk number 9: 
###################################################
if(require("padi") && checkPADIserver("ets"))
  z <- l(TSmodel(eg4.DSE.model), trimNA(
    freeze(eg4.DSE.data.names))) #requires padi and correct databases 


###################################################
### chunk number 10: 
###################################################
z <- forecast(TSmodel(eg4.DSE.model), new.data) 


###################################################
### chunk number 11: 
###################################################
z <- forecast(TSmodel(eg4.DSE.model), trimNA(new.data),
 conditioning.inputs = inputData(new.data)) 


###################################################
### chunk number 12: 
###################################################
tfplot(z, start=c(1990,6)) 


###################################################
### chunk number 13: 
###################################################
z <- forecast(eg4.DSE.model, conditioning.inputs.forecasts = matrix(.5,6,1)) 


###################################################
### chunk number 14: 
###################################################
if(require("padi") && checkPADIserver("ets"))
   z <- forecast(TSmodel(eg4.DSE.model), freeze(eg4.DSE.data.names),
   conditioning.inputs.forecasts = matrix(.5,6,1)) 
   #requires padi and correct databases 


###################################################
### chunk number 15: 
###################################################
summary(z)

print(z)

tfplot(z)

tfplot(z, start=c(1990,1)) 


###################################################
### chunk number 16: 
###################################################
forecasts(z)[[1]]


###################################################
### chunk number 17: 
###################################################
tfwindow(forecasts(z)[[1]], start=c(1994,1), warn=FALSE) 


###################################################
### chunk number 18: 
###################################################
z <- l(TSmodel(eg4.DSE.model), new.data)


###################################################
### chunk number 19: 
###################################################
tfplot(z)


###################################################
### chunk number 20: 
###################################################
z <- featherForecasts(TSmodel(eg4.DSE.model), new.data)

tfplot(z)


###################################################
### chunk number 21: 
###################################################
z <- featherForecasts(TSmodel(eg4.DSE.model), new.data, 
 from.periods = c(20, 50, 60, 70, 80), horizon=150)


###################################################
### chunk number 22: 
###################################################
tfplot(z)


###################################################
### chunk number 23: 
###################################################
z <- horizonForecasts(TSmodel(eg4.DSE.model), new.data, horizons = c(1,3,6))



###################################################
### chunk number 24: 
###################################################
tfplot(z)


###################################################
### chunk number 25: 
###################################################
fc <- forecastCov(TSmodel(eg4.DSE.model), data=eg4.DSE.data)

tfplot(fc)

tfplot(forecastCov(TSmodel(eg4.DSE.model), data=eg4.DSE.data, horizons=
1:4)) 


###################################################
### chunk number 26: 
###################################################
fc <- forecastCov(TSmodel(eg4.DSE.model), data=eg4.DSE.data, zero=T,
trend=T)

tfplot(fc)


###################################################
### chunk number 27: 
###################################################
mod1 <- ARMA(A=array(c(1,-.25,-.05), c(3,1,1)), B=array(1,c(1,1,1)))

mod2 <- ARMA(A=array(c(1,-.8, -.2 ), c(3,1,1)), B=array(1,c(1,1,1)))

mod3 <- ARMA(
 A=array(c( 
  1.00,-0.06,0.15,-0.03,0.00,0.02,0.03,-0.02,0.00,-0.02,-0.03,-0.02,
  0.00,-0.07,-0.05,0.12,1.00,0.20,-0.03,-0.11,0.00,-0.07,-0.03,0.08,
  0.00,-0.40,-0.05,-0.66,0.00,0.00,0.17,-0.18,1.00,-0.11,-0.24,-0.09
  ), c(4,3,3)), 
 B=array(diag(1,3), c(1,3,3)))


###################################################
### chunk number 28: 
###################################################
z <-  MonteCarloSimulations(mod1, simulation.args=list(sampleT=100))

tfplot(z)

distribution(z)


###################################################
### chunk number 29: 
###################################################
e.ls.mod1 <- EstEval( mod1, replications=100,
  simulation.args=list(sampleT=100, sd=1),
  estimation="estVARXls",
  estimation.args=list(max.lag=2),
  criterion="TSmodel"
#  rng=list(kind="default", normal.kind="default", 
#  seed=c(13,44,1,25,56,0,6,33,22,13,13,0))# Splus seed - see below
 
  ) 


###################################################
### chunk number 30: 
###################################################
rng=list(kind="Wichmann-Hill", seed=c(979,1479,1542),
 normal.kind="Box-Muller")


###################################################
### chunk number 31: 
###################################################
setRNG(kind="Wichmann-Hill", seed=c(979,1479,1542),
 normal.kind="Box-Muller")


###################################################
### chunk number 32: 
###################################################
e.ls.mod2 <- EstEval( mod2, replications=100, 

 simulation.args=list(sampleT=100, sd=1), 

 estimation="estVARXls", estimation.args=list(max.lag=2), 

 criterion="TSmodel"

 #rng=list(kind="default", normal.kind="default",

 #seed=c(13,43,7,57,62,3,30,29,24,54,47,2))  #Splus seed

 )


###################################################
### chunk number 33: 
###################################################
par(mfcol=c(2,1)) # set the number of plots on the graphics device

tfplot(coef(e.ls.mod1)) 


###################################################
### chunk number 34: 
###################################################
tfplot(coef(e.ls.mod2)) 


###################################################
### chunk number 35: 
###################################################
par(mfcol=c(2,1)) # set the number of plots on the graphics device

tfplot(coef(e.ls.mod1), cumulate=FALSE, bounds=FALSE)



###################################################
### chunk number 36: 
###################################################
tfplot(coef(e.ls.mod2), cumulate=FALSE, bounds=FALSE) 


###################################################
### chunk number 37: 
###################################################
distribution(coef(e.ls.mod1), bandwidth=.2) 


###################################################
### chunk number 38: 
###################################################
distribution(coef(e.ls.mod2), bandwidth=.2) 


###################################################
### chunk number 39: 
###################################################
e.ls.mod1.roots <- roots(e.ls.mod1)

plot(e.ls.mod1.roots) 

plot(e.ls.mod1.roots, complex.plane=F) 

plot(roots(e.ls.mod2), complex.plane=F) 

distribution(e.ls.mod1.roots, bandwidth=.2) 


###################################################
### chunk number 40: 
###################################################
distribution(roots(e.ls.mod2), bandwidth=.1) 


###################################################
### chunk number 41: 
###################################################
pc <- forecastCovEstimatorsWRTtrue(mod3,

 estimation.methods = list(estVARXls=list(max.lag=6)),

 est.replications=2, pred.replications=10

# rng=list(kind="default", normal.kind="default", 

# seed=c( 53,41,26,39,10,1,19,25,56,32,28,3))  #Splus seed

) 


###################################################
### chunk number 42: 
###################################################
pc.rd <- forecastCovReductionsWRTtrue(mod3,

 estimation.methods = list(estVARXls=list(max.lag=3)),

 est.replications=2, pred.replications=10

# rng = list(kind = "default", normal.kind="default", 

# seed=c(29,55,47,18,33,1,15,15,34,46,13,2)) 

)


###################################################
### chunk number 43: 
###################################################
data(eg1.DSE.data, package="dse1")
z <-outOfSample.forecastCovEstimatorsWRTdata(trimNA(eg1.DSE.data),

estimation.sample=.5,

estimation.methods = list(estVARXar=NULL, estVARXls=NULL), 

trend=T)


###################################################
### chunk number 44: 
###################################################
tfplot(z)


###################################################
### chunk number 45: 
###################################################
z <-outOfSample.forecastCovEstimatorsWRTdata( trimNA(eg1.DSE.data),

 estimation.sample=.5,

 estimation.methods = list(

 estBlackBox4=list(max.lag=3, verbose=F),

 estVARXls=list(max.lag=3)), 

 trend=T, zero=T)

tfplot(z)


###################################################
### chunk number 46: 
###################################################
zz <- horizonForecasts(TSmodel(z, select=1) , TSdata(z), horizons=c(1,3,6))


